#
# WIN32 makefile: use with  'nmake -f msklog.mak'
#


# Compiler (this will use Microsoft Visual C++, run VCVARS32.BAT in the
#           bin directory of that distribution to compiler correctly in
#           a DOS window)
CC=cl

#
# The source directory
#
SRC_D=.
# The output directory for everything intersting
BIN_D=$(SRC_D)\..\bin

# The output directory for all the temporary muck
OBJ_D=$(SRC_D)\..\obj

#DEE for src in AFS, and obj, bin on local machine
BIN_D=d:\build\bin
OBJ_D=d:\build\obj

#
# Microsoft Platform SDK to get the good versions of Sspi.h and NTsecAPI.h
#

MSSDK_INC_D="C:\Program Files\Microsoft Platform SDK\Include"

#
# OPENAFS directories 
#
AFS_INC_D=D:\build\openafs-1.3.50\DEST\free\include
AFS_LIB_D=D:\build\openafs-1.3.50\DEST\free\lib
FIX_KVNO_INC_D=D:\build\openafs-1.3.50\src\rxkad
AFS_CFLAGS=-DAFS_NT40_ENV     

# if needed add -DFIX_KVNO or -DNO_MS_PAC to AFS_CFLAGS 

AAAA_LIBS= $(AFS_LIB_D)\afs\afsprot.lib \
	$(AFS_LIB_D)\afsubik.lib \
	$(AFS_LIB_D)\afs\afsauth.lib \
      $(AFS_LIB_D)\afs\afscmd.lib \

A_LIBS = \
	$(AFS_LIB_D)\afs\afsauth.lib \
	$(AFS_LIB_D)\afs\afskauth.lib \
	$(AFS_LIB_D)\afs\afsprot.lib \
	$(AFS_LIB_D)\afs\afspioctl.lib \
	$(AFS_LIB_D)\afs\afsaudit.lib \
	$(AFS_LIB_D)\afs\afsutil.lib \
	$(AFS_LIB_D)\afs\afscom_err.lib \
	$(AFS_LIB_D)\afs\afsreg.lib \
	$(AFS_LIB_D)\afs\afscmd.lib \
	$(AFS_LIB_D)\afsubik.lib \
	$(AFS_LIB_D)\afsrxkad.lib \
	$(AFS_LIB_D)\afsdes.lib \
	$(AFS_LIB_D)\afsrx.lib \
	$(AFS_LIB_D)\afslwp.lib \
	$(AFS_LIB_D)\libosi.lib \
	$(AFS_LIB_D)\libafsconf.lib


LINK=link
LFLAGS=/DEBUG /nologo /subsystem:console /machine:I386 /opt:ref
WLFLAGS=/nologo /subsystem:windows /machine:I386 /opt:ref 


CP=copy
RM=del
RC=rc
RANLIB=
MKDIR=mkdir
MKLIB=lib
MLFLAGS= /nologo /subsystem:console /machine:I386 /opt:ref /dll

# Compiler flags...
#
# add /Zi and -DDEBUG for debug
CFLAG=  /MD /W3  /G5 /Ox /O2 /Ob2 /Gs0 /GF /Gy /nologo -DWIN32 -DWIN32_LEAN_AND_MEAN  

#secur32.lib is the Security/sspi librarys

EX_LIBS=wsock32.lib user32.lib gdi32.lib advapi32.lib secur32.lib


######################################################
# 
######################################################

INC=-I$(SRC_D)  -I$(AFS_INC_D) -I$(MSSDK_INC_D) -I$(FIX_KVNO_INC_D)
#
APP_CFLAGS=$(INC) $(CFLAG) $(AFS_CFLAGS) 
RFLAGS=$(INC)


#############################################

E_OBJ=$(OBJ_D)\msklog.obj \
        $(OBJ_D)\msklog_ms.obj \
        $(OBJ_D)\fixkvno.obj


###################################################################
all: banner $(OBJ_D) $(BIN_D) obj  exe


# application objects 

$(OBJ_D)\msklog.obj: $(SRC_D)\msklog.c
	$(CC) /Fo$(OBJ_D)\msklog.obj $(APP_CFLAGS) $(INC) -c $(SRC_D)\msklog.c

$(OBJ_D)\fixkvno.obj: $(SRC_D)\fixkvno.c
        $(CC) /Fo$(OBJ_D)\fixkvno.obj $(APP_CFLAGS) $(INC) -c $(SRC_D)\fixkvno.c

$(OBJ_D)\msklog_ms.obj: $(SRC_D)\msklog_ms.c
        $(CC) /Fo$(OBJ_D)\msklog_ms.obj $(APP_CFLAGS) $(INC) -c $(SRC_D)\msklog_ms.c

# appliction exes

$(BIN_D)\msklog.exe: $(E_OBJ) 
        $(LINK) $(LFLAGS) /out:$(BIN_D)\msklog.exe @<< 
	$(E_OBJ) $(A_LIBS) $(EX_LIBS)
<<

banner:

$(OBJ_D):
	$(MKDIR) $(OBJ_D)

$(BIN_D):
	$(MKDIR) $(BIN_D)


headers: $(HEADER)

lib: 

obj: $(E_OBJ)

exe:  $(BIN_D)\msklog.exe

clean:
	$(RM) $(OBJ_D)\*.*

vclean:
	$(RM) $(OBJ_D)\*.*
	$(RM) $(BIN_D)\*.*
	


