
//#define DEE fprintf(stderr,"Debug %s %d\n",__FILE__,__LINE__);
#define DEE

#define UNICODE
#define _UNICODE

#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#define SECURITY_WIN32
#include <security.h>
#include <ntsecapi.h>

#include "msklog.h"

static
void hexdump(char * comment, void * in, int len)
{
    unsigned char *p = (unsigned char *)in;
    int i;

    fprintf(stderr,"%s",comment);
    for (i=0; i<len; i++)
    {
        if ((i & 3) == 0) fprintf(stderr, " ");
        if ((i & 31) == 0) fprintf(stderr,"\n    ");
        fprintf(stderr,"%02x", p[i]);
    }
    fprintf(stderr,"\n");
}


static
time_t
TimeToAFSTime( LARGE_INTEGER *ltime)
{
    FILETIME ftime;
    SYSTEMTIME stime;
    struct tm utime;
    ftime.dwLowDateTime=ltime->LowPart;
    ftime.dwHighDateTime=ltime->HighPart;
	FileTimeToSystemTime(&ftime, &stime);
    utime.tm_sec=stime.wSecond;
    utime.tm_min=stime.wMinute;
    utime.tm_hour=stime.wHour;
    utime.tm_mday=stime.wDay;
    utime.tm_mon=stime.wMonth-1;
    utime.tm_year=stime.wYear-1900;
    utime.tm_isdst=-1;
    return(mktime(&utime));
}

WCHAR *
ANSIToWide(char *in)
{
	int i;
	WCHAR * out;

	i = MultiByteToWideChar(CP_ACP, 0, in, -1, NULL, 0);

	out =  malloc(i * sizeof(WCHAR));
	if (out) {
		 MultiByteToWideChar(CP_ACP, 0, in, -1, out, i*sizeof(WCHAR));
	}
	return out;
}


/******************************************************************/

long
msklog_get_ticket(char * user,         /* null or user to use */ 
				  char * password,     /* password to use if user */
				  char * cell,         /* needed for afs/cell@realm*/
				  void ** pticket,     /* returned ticket */
				  int * pticketlen,    /* size of ticket */
				  void * sessionKey,   /* session key 8 bytes */
				  int * startTime,     /* start time */
				  int * endTime,       /* endtime */
				  char * clientuser,  /* buf for user name found */    
				  int clientuserlen,   /* max size of output name */
				  char * clientrealm, /* buf for user realm found */
				  int clientrealmlen   /* max size of output name */
				  )

{
	NTSTATUS Status = ERROR_SUCCESS;
	NTSTATUS ProtocolStatus = ERROR_SUCCESS;

	HANDLE LsaHandle=NULL; /* must cleanup */
	LSA_STRING PackageName;   
    ULONG AuthenticationPackage;

	SECURITY_STATUS maj_status = 0;
	CredHandle cred_handle = {0,0}; /* cleanup */

	/* use ANSI version of following structure */
	SEC_WINNT_AUTH_IDENTITY_EXA AuthIdentity; /* no cleanup */
	SecPkgCredentials_Names CredName = {NULL}; /* must cleanup */

	PWCHAR pwuser = NULL;   /* points into CredName */
	PWCHAR pwrealm = NULL;  /* points into CredName */
	PWCHAR pwcell = NULL;     /* local cell */
	int wcellLen;
	PWCHAR pwcellx = NULL;     /* local cell  must free */
	PWCHAR wcp;
	WCHAR pwservice[]  = L"afs/";     
	int wserviceLen;
	char * dom = NULL;

	PKERB_RETRIEVE_TKT_REQUEST pTktRequest = NULL;
	ULONG TktRequestLen = 0;
	USHORT TargetNameLen = 0;
	PKERB_RETRIEVE_TKT_RESPONSE pTktResponse = NULL; /* free */
	ULONG TktResponseLen = 0;
	
	char * newtkt = NULL;
	size_t newtktlen = 0;
	int code = 0;

	/* get an LSA Handle for Kerberos Package */
DEE;

	Status = LsaConnectUntrusted(&LsaHandle);
	if (Status != ERROR_SUCCESS) {
		goto cleanup;
	}
DEE;
	PackageName.Buffer = MICROSOFT_KERBEROS_NAME_A;
	PackageName.Length = strlen(PackageName.Buffer); 
	PackageName.MaximumLength = PackageName.Length +1;
	
	Status = LsaLookupAuthenticationPackage(LsaHandle,
						&PackageName,  
						&AuthenticationPackage);
DEE;
	if (Status != ERROR_SUCCESS) {
		goto cleanup;
	}
DEE;

	/*
	 * Using SSPI, get acquire a credential for loged in user
     * or new user, if user and password where specified
	 */


	memset(&AuthIdentity, 0, sizeof(AuthIdentity));
	AuthIdentity.Version = SEC_WINNT_AUTH_IDENTITY_VERSION;
	AuthIdentity.Length = sizeof(AuthIdentity);
	AuthIdentity.Flags = SEC_WINNT_AUTH_IDENTITY_ANSI;

#ifdef NO_MS_PAC
	AuthIdentity.Flags |= SEC_WINNT_AUTH_IDENTITY_ONLY;
#endif

DEE;
	/* 
	 * default of no user or password means use logged in user 
	 * We are using the ANSI version of the struct. so password 
	 * works, the flag in the struct says its ASNI
	 */

	if (user) {
		AuthIdentity.User = user;
		dom = strchr(user,'@');
		if (dom) {
			AuthIdentity.UserLength = dom - user;
			dom++;
		} else {
			AuthIdentity.UserLength = strlen(AuthIdentity.User);
		}
	}
	if (dom) {
		AuthIdentity.Domain = dom;
		AuthIdentity.DomainLength = strlen(AuthIdentity.Domain);
		
	}
	if (password) {
		AuthIdentity.Password = password;
		AuthIdentity.PasswordLength = strlen(AuthIdentity.Password);
	}

	maj_status = AcquireCredentialsHandle(NULL,
						MICROSOFT_KERBEROS_NAME,
						SECPKG_CRED_OUTBOUND,
						NULL,
						&AuthIdentity,
						NULL,
						NULL,
						&cred_handle,
						NULL);

DEE;
	if (maj_status != SEC_E_OK) {
		goto cleanup;
	}

DEE;
	maj_status = QueryCredentialsAttributes(&cred_handle,
									SECPKG_CRED_ATTR_NAMES,
									&CredName);
DEE;
	if (maj_status != SEC_E_OK) {
		goto cleanup;
	}

DEE;
	/* break the principal into user and realm */
	/* and return as client user and cell. No instance for now */
	pwuser = CredName.sUserName;
	pwrealm = wcschr(CredName.sUserName,L'@');
DEE;
	if (pwrealm) {
		*pwrealm = 0;
		pwrealm++;
	}

	WideCharToMultiByte(CP_ACP, 0, pwuser, lstrlen(pwuser)*sizeof(WCHAR),
			clientuser, clientuserlen, NULL, NULL);

DEE;
	WideCharToMultiByte(CP_ACP, 0, pwrealm, lstrlen(pwrealm)*sizeof(WCHAR),
			clientrealm, clientrealmlen, NULL, NULL);
	
DEE;

	if (cell) {
		pwcell = ANSIToWide(cell);
		if (pwcell == NULL) {
			maj_status = GetLastError();
			goto cleanup;
		}
		pwcellx = pwcell;  /* free later */
	} else {
		pwcell = pwrealm;  /* should never be needed */
	}
	wcellLen = lstrlen(pwcell); /* in units of WCHAR */

DEE;
	wserviceLen = lstrlen(pwservice);

	/* now setup to get a ticket for afs/<cell> */
	/* The request must be in a single buffer!!! */

	TargetNameLen = wserviceLen * sizeof(WCHAR) + 
					wcellLen * sizeof(WCHAR);
	TktRequestLen = sizeof(KERB_RETRIEVE_TKT_REQUEST) 
							+ TargetNameLen;

	pTktRequest = malloc(TktRequestLen); 
	if (pTktRequest == NULL) {
		maj_status = GetLastError();
		goto cleanup;
	}
	
	memset(pTktRequest, 0, TktRequestLen);

	pTktRequest->MessageType = KerbRetrieveEncodedTicketMessage;
	pTktRequest->LogonId.LowPart = 0;
	pTktRequest->LogonId.HighPart = 0;
	pTktRequest->TargetName.Length = TargetNameLen;
    pTktRequest->TargetName.MaximumLength = pTktRequest->TargetName.Length;
	wcp = (PWSTR) (pTktRequest + 1); /* point at end and add target */

	pTktRequest->TargetName.Buffer = wcp; 
	
	/* build target string  of afs/<cell> in buffer */
	memcpy(wcp,pwservice, wserviceLen *sizeof(WCHAR));
	wcp = wcp + wserviceLen;
	memcpy(wcp,pwcell, wcellLen * sizeof(WCHAR));
	
	pTktRequest->TicketFlags = 0L;
	pTktRequest->CacheOptions = KERB_RETRIEVE_TICKET_DONT_USE_CACHE
							  | KERB_RETRIEVE_TICKET_USE_CREDHANDLE;
	/* e-type restricted for now - OpenAFS servers <= 1.2.x */
	pTktRequest->EncryptionType = KERB_ETYPE_DES_CBC_CRC;
	pTktRequest->CredentialsHandle.dwLower  = cred_handle.dwLower;
	pTktRequest->CredentialsHandle.dwUpper  = cred_handle.dwUpper;
		
DEE;
	Status = LsaCallAuthenticationPackage(LsaHandle,
								AuthenticationPackage,
								pTktRequest,
								TktRequestLen,
								&pTktResponse,
								&TktResponseLen,
								&ProtocolStatus);
DEE;
	if (Status != ERROR_SUCCESS ) {
		goto cleanup;
	}

DEE;
	if (ProtocolStatus != ERROR_SUCCESS) {
		Status = ProtocolStatus;
		goto cleanup;
	}

DEE;
	/* got the K5 ticket, now get what we need from it */

	newtkt = malloc(pTktResponse->Ticket.EncodedTicketSize);
	if (newtkt == 0) {
		maj_status = GetLastError();
		goto cleanup;
	}
DEE;
	newtktlen = pTktResponse->Ticket.EncodedTicketSize;
	
	memcpy(newtkt, pTktResponse->Ticket.EncodedTicket,
					pTktResponse->Ticket.EncodedTicketSize);

	memcpy(sessionKey,pTktResponse->Ticket.SessionKey.Value, 
					8 /* Must be a DES key today */);
	
    *startTime = TimeToAFSTime(&(pTktResponse->Ticket.StartTime));
	*endTime   = TimeToAFSTime(&(pTktResponse->Ticket.EndTime));
	
DEE;
cleanup:
	if (pTktResponse) {
		LsaFreeReturnBuffer(pTktResponse);
	}
DEE;
	if (pTktRequest) {
		free(pTktRequest);
	}

DEE;
	if (AuthenticationPackage) {
		/* not sure if need to free */
	}

DEE;
	FreeCredentialsHandle(&cred_handle);

DEE;
	if (pwcellx) {
		free(pwcellx);
	}

DEE;
	if (CredName.sUserName) {
		FreeContextBuffer(&CredName);
	}

DEE;
	if (Status != ERROR_SUCCESS) {
		 maj_status = LsaNtStatusToWinError(Status);
	}
	
DEE;
	*pticket = newtkt;
	*pticketlen = newtktlen; 

DEE;
	return maj_status;

}
